Need help with arrow?
Click the “chat” button below for chat support from the developer who created it, or find similar developers for support.

About the developer

arrow-kt
4.6K Stars 323 Forks Other 5.4K Commits 40 Opened issues

Description

Λrrow - Functional companion to Kotlin's Standard Library

Services available

!
?

Need anything else?

Contributors list

Maven Central Latest snapshot Kotlin version

License StackOverflow Twitter

Λrrow is a library for Typed Functional Programming in Kotlin.

Arrow aims to provide a lingua franca of interfaces and abstractions across Kotlin libraries. For this, it includes the most popular data types such as

Option
,
Either
,
Validated
etc and functional operators such as
traverse
and computation blocks to empower users to write pure FP apps and libraries built atop higher order abstractions.

Use the list below to learn more about Λrrow's main features.

Curated external links

If you have a blog post, talk, or upcoming event on Arrow, please considering opening an issue or PR to add to the collection over at the Arrow Media repo.

Join Us

Arrow is an inclusive community powered by awesome individuals like you. As an actively growing ecosystem, Arrow and its associated libraries and toolsets are in need of new contributors! We have issues suited for all levels, from entry to advanced, and our maintainers are happy to provide 1:1 mentoring. All are welcome in Arrow.

If you’re looking to contribute, have questions, or want to keep up-to-date about what’s happening, please follow us here and say hello!

Find more details in CONTRIBUTING.

Setup

JDK

Make sure to have the latest version of JDK 1.8 (or higher) installed.

JDK 16 doesn't currently work but will do once we upgrade to Gradle 7.0

Android

Arrow supports Android starting on API 21 and up.

Gradle

Basic Setup

In your project's root

build.gradle
, append this repository to your list:
allprojects {
    repositories {
        mavenCentral()
    }
}

Add the dependencies into the project's

build.gradle
:
Λrrow Core
def arrow_version = "1.0.0"
dependencies {
    implementation "io.arrow-kt:arrow-core:$arrow_version"
}
Λrrow Core + Λrrow Optics
apply plugin: 'kotlin-kapt'

def arrow_version = "1.0.0" dependencies { implementation "io.arrow-kt:arrow-optics:$arrow_version" kapt "io.arrow-kt:arrow-meta:$arrow_version" }

Λrrow Core + Λrrow Fx
def arrow_version = "1.0.0"
dependencies {
    implementation "io.arrow-kt:arrow-fx-coroutines:$arrow_version"
}

BOM file

To avoid specifying the Arrow version for every dependency, a BOM file is available:

    implementation platform("io.arrow-kt:arrow-stack:$arrow_version")

implementation "io.arrow-kt:arrow-core"
implementation "io.arrow-kt:arrow-fx-coroutines"
...

Maven

Basic Setup

Make sure to have at least the latest version of JDK 1.8 installed. Add to your

pom.xml
file the following properties:
xml

    1.4.0
    1.0.0

Add the dependencies that you want to use:

xml

    io.arrow-kt
    arrow-core
    ${arrow.version}

Enabling kapt for the Optics DSL

For the Optics DSL, enable annotation processing using Kotlin plugin:

xml

    org.jetbrains.kotlin
    kotlin-maven-plugin
    ${kotlin.version}
    
        
            kapt
            
                kapt
            
            
                
                    src/main/kotlin
                
                
                    
                        io.arrow-kt
                        arrow-meta
                        ${arrow.version}
                    
                
            
        
        
            compile
            compile
            
                compile
            
            
                
                    src/main/kotlin
                
            
        
        
            test-compile
            test-compile
            
                test-compile
            
        
    

BOM file

To avoid specifying the Arrow version for every dependency, a BOM file is available:

  
    
      
        io.arrow-kt
        arrow-stack
        ${arrow.version}
        pom
        import
      
    
  
  
    ...
  

Next development version

If you want to try the latest features, replace

1.0.0
with
1.0.1-SNAPSHOT
and add this repository:
allprojects {
    repositories {
        ...
        maven { url "https://oss.sonatype.org/content/repositories/snapshots/" }
    }
}

License

Copyright (C) 2017 The Λrrow Authors

Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with the License. You may obtain a copy of the License at

http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.

We use cookies. If you continue to browse the site, you agree to the use of cookies. For more information on our use of cookies please see our Privacy Policy.